/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#include "PerfectStereoElecDriver.h"
#include "StereoElecDef.h"

using namespace std;

namespace stereo_elec {

/*
 * Constructor
 */
PerfectStereoElecDriver::PerfectStereoElecDriver(StereoElecDriver* owner) :
	StereoElecState(owner) {
	/* Empty */
}

/*
 * Destructor
 */
PerfectStereoElecDriver::~PerfectStereoElecDriver() {
	/* Empty */
}

/*
 * init
 */
void PerfectStereoElecDriver::init() {

}

/*
 * clear
 */
void PerfectStereoElecDriver::clear() {

}

/*
 * writeParam
 */
void PerfectStereoElecDriver::writeParam() {
}

/*
 * readInfos
 */
void PerfectStereoElecDriver::readInfos() {
}
/*
 * start
 */
void PerfectStereoElecDriver::start() {
	// Start command
	int32 mode = owner()->mode();

	if (mode == acquisition::GateCommon::TIME_MODE) {
		owner()->time.update(owner()->time.setpoint());
		owner()->counts.update(1);
		owner()->counts2.update(2);
		owner()->counts3.update(3);
	} else if (mode == acquisition::GateCommon::COUNTER1_MODE) {
		owner()->time.update(1);
		owner()->counts.update(owner()->counts.setpoint());
		owner()->counts2.update(2);
		owner()->counts3.update(3);
	} else if (mode == acquisition::GateCommon::COUNTER2_MODE) {
		owner()->time.update(1);
		owner()->counts.update(2);
		owner()->counts2.update(owner()->counts2.setpoint());
		owner()->counts3.update(3);
	} else if (mode == acquisition::GateCommon::COUNTER3_MODE) {
		owner()->time.update(1);
		owner()->counts.update(2);
		owner()->counts2.update(3);
		owner()->counts3.update(owner()->counts3.setpoint());
	}
}

/*
 * stop
 */
void PerfectStereoElecDriver::stop() {
}

/*
 * read
 */
void PerfectStereoElecDriver::read() {
	/*float64 sum = 0;
	int32 size = owner()->dataSize();
	int32* tab = owner()->data();
	if (m_FirstRead == 0) {
		for (int32 i = 0; i < size; i++) {
			tab[i] = i;
			sum = sum + tab[i];
		}
		++m_FirstRead;
	} else {
		for (int32 i = 0; i < size; i++) {
			tab[i] = tab[i] + 1;
			sum = sum + tab[i];
		}
	}
	owner()->sum.update(sum);
	owner()->data.sendEvent();*/
}

/*
 * synchroniseRead
 */
void PerfectStereoElecDriver::synchroniseRead() {
	read();
	owner()->m_SynchroniseReadTerminated = true;
}

/*
 * readStatus
 */
void PerfectStereoElecDriver::readStatus() {
	owner()->startActivated = false;
//	owner()->status.update(COUNT_END);
//	owner()->computeGateStatus(COUNT_END);
	owner()->computeAcquisitionStatus(0);
	owner()->computeDetectorStatus(0);
	if (owner()->m_SynchroniseReadActivated == true) {
		if (owner()->m_SynchroniseReadTerminated == true) {
			owner()->m_SynchroniseReadActivated = false;
			owner()->m_SynchroniseReadTerminated = false;
			owner()->commandProgression = PROGRESSION_END_DEVICE_CONTAINER;
		}
	} else {
		owner()->commandProgression = PROGRESSION_END_DEVICE_CONTAINER;
	}
}
void PerfectStereoElecDriver::config() {

}



}
